unit AEXE;

// AEXE version 2.00
// Package of Components for D2,D3,D4,D5,D6
// Copyright  2000-2001 by Peric
// Birthday of Component 28.01.2001.
// E-mail: pericddn@ptt.yu
// If I' find any error or rubbish in AEXE please send me Your suggest or Reclamation.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs,ShellApi;

  {$R AEXE.res}

type
  TOnRunEvent = procedure(Sender: TObject) of object;
  TOnKillEvent = procedure(Sender: TObject) of object;
  TAEXE = class(TComponent)

  private

    FOnRun:TOnRunEvent;
    FOnKill:TOnKillEvent;
    FPath,FCop,FEXEname: string;
    W:integer;
    function GetCop: string;
    function GetPath: string;
    Function KillTask(FileName:String):integer;
    function GetEXEname: string;
    procedure SetCop(const Value: string);
    procedure SetPath(APath: string);
    procedure SetEXEname(AEXEname: string);

  protected

  public

    constructor Create(Aowner:Tcomponent);override;
    destructor Destroy; override;
    procedure Run;
    procedure Kill;

  published

    property Path:string
    read GetPath write SetPath;
    property FileName:string
    read GetExename write SetEXEname;
    property Version: string read GetCop write SetCop;
    property OnRun:TOnRunEvent read FOnRun write FOnRun;
    property OnKill:TOnKillEvent read FOnKill write FOnKill;

  end;

procedure Register;

implementation


Uses tlhelp32;


procedure Register;
begin
  RegisterComponents('PDJ', [TAEXE]);
end;

constructor TAEXE.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
FCop :='Version 2.00, Copyright  2000-2001 by Peric, E-mail: pericddn@ptt.yu';
end;

destructor TAEXE.Destroy;
begin
inherited Destroy;
end;

{$WARNINGS OFF}
Function TAEXE.KillTask(FileName:String):integer;
var
ContinueLoop:BOOL;
FSnapshotHandle:THandle;
FProcessEntry32:TProcessEntry32;
const
PROCESS_TERMINATE=$0001;
begin
FSnapshotHandle:=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
FProcessEntry32.dwSize:=Sizeof(FProcessEntry32);
ContinueLoop:=Process32First(FSnapshotHandle,FProcessEntry32);
while integer(ContinueLoop)<>0 do
begin
if
((UpperCase(ExtractFileName(FProcessEntry32.szExeFile))=UpperCase(FileName))
or (UpperCase(FProcessEntry32.szExeFile)=UpperCase(FileName)))
then

Result:=Integer(TerminateProcess(OpenProcess(PROCESS_TERMINATE,BOOL(0),FProcessEntry32.th32ProcessID),0));
ContinueLoop:=Process32Next(FSnapshotHandle,FProcessEntry32);
end;
CloseHandle(FSnapshotHandle);
end;
{$WARNINGS ON}

    function TAEXE.GetCop: string;
begin
     Result:=FCop;
end;

    function TAEXE.GetPath: string;
begin
     Result:=FPath;
end;

    function TAEXE.GetEXEname: string;
begin
     Result:=FEXEname;
end;

    procedure TAEXE.SetCop(const Value: string);
begin
     FCop:=FCop;
end;

procedure TAEXE.Run;
var
EXERUN:String;
begin
     if (FPath='') and (FEXEname = '') then
     EXERUN := Application.ExeName;
     if (FPath='') and (FEXEname >'') then
     EXERUN:= extractfilepath(application.exename)+ '\'+ FEXEname;
     if (FPath>'') and (FEXEname >'') then
     EXERUN:= FPath+ '\'+ FEXEname;
     if (FPath>'') and (FEXEname ='') then
     begin
     MessageBeep(0);
     MessageDlg('  FileName unknown !  ', mtError,[mbOk], 0);
     exit;
     end;
     if ShellExecute(0, 'open', PChar(EXERUN), '', '', SW_SHOWNORMAL)=ERROR_FILE_NOT_FOUND then
     begin
     MessageBeep(0);
     MessageDlg('  FileName not found !  ', mtError,[mbOk], 0);
     Exit;
     end;
     if Assigned(FOnRun) then begin FOnRun(Self);
     W:=1;
     end;

end ;

procedure TAEXE.Kill;
var
EXEKILL:string;

begin
     if (FPath='') and (FEXEname = '') then
     EXEKILL:= Application.ExeName;
     if (FPath='') and (FEXEname >'') then
     EXEKILL:= extractfilepath(application.exename)+ FEXEname+'.exe';
     if (FPath>'') and (FEXEname >'') then
     EXEKILL:= FPath+'\'+ FEXEname+'.exe';
     if (FPath>'') and (FEXEname ='') then
     begin
     MessageBeep(0);
     MessageDlg('  FileName unknown !  ', mtError,[mbOk], 0);
     exit;
     end;
     KillTask(EXEKILL);
     if W=1 then
     if Assigned(FOnKill) then FOnKill(Self);


end ;

    procedure TAEXE.SetPath(APath:string);
begin
     FPath:=APath;
end;

    procedure TAEXE.SetEXEname(AEXEname:string);
begin
     FEXEname:=AEXEname;
end;

end.
